import { Query } from '../types';
/**
 * Get query parameters from the specified request url.
 * @param {string} reqUrl
 */
export declare function getQuery(reqUrl: string): Query;
/**
 * Check whether or not this specified obj is an object.
 * @param {any} obj
 */
export declare function isObject(obj: any): boolean;
/**
 * Try to convert an object like string to an object.
 * @param {any} body
 */
export declare function tryToParseObject(body: any): any;
/**
 * Sleep the specified number of milliseconds.
 * @param {number} ms
 */
export declare function sleep(ms: number): Promise<unknown>;
/**
 * Convert string to arraybuffer.
 * @param {string} str
 */
export declare function str2arrayBuffer(str: string): ArrayBuffer;
/**
 * Whether or not the specified data is arraybuffer.
 * @param {string} str
 */
export declare function isArrayBuffer(data: any): boolean;
/**
 * Get current date.
 */
export declare function currentDate(): string;
/**
 * Get current time.
 */
export declare function currentTime(): string;
/**
 * Get current datetime.
 */
export declare function currentDatetime(): string;
/**
 * Check current envrioment: nodejs or not.
 * Note: arrow function is required.
 */
export declare function isNodejs(): boolean;
