"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = __importDefault(require("http"));
var https_1 = __importDefault(require("https"));
var zlib = __importStar(require("zlib"));
/**
 * In nodejs enviroment, by default for XMLHttpRequest, fetch and wx.request, http-request-mock
 * does a fallback request by simply using http/https native request module, which encodes the
 * response body with utf8. It may not meet your requirement in some complex applications.
 * So, you can use another third fake (XMLHttpRequest, fetch, wx.request)request library
 * instead before calling setupForUnitTest method if you had some problems with the fallback request.
 *
 * @param {string} url
 * @param {string} method
 * @param {object} headers
 * @param {any} body
 * @param {object} opts
 * @returns
 */
function fallback(url, method, headers, body, opts) {
    if (opts === void 0) { opts = {}; }
    return new Promise(function (resolve, reject) {
        var isHttps = /^https:/i.test(url);
        var protocol = isHttps ? https_1.default : http_1.default;
        var reqOpts = __assign({ useNativeModule: true, method: (method || 'GET').toUpperCase(), headers: headers || {} }, opts);
        var req = protocol.request(url, reqOpts, function (response) {
            getResponseBody(response).then(function (body) {
                resolve({ body: body, response: response });
            }).catch(function (err) {
                req.emit('error', err);
            });
        });
        req.on('error', function (err) {
            reject(err);
        });
        if (body) {
            if (typeof body === 'string'
                || (body instanceof Buffer)
                || (body instanceof ArrayBuffer)
                || (body instanceof SharedArrayBuffer)
                || (body instanceof Uint8Array)) {
                req.write(Buffer.from(body));
            }
            else {
                req.write(Buffer.from(JSON.stringify(body)));
            }
        }
        req.end();
    });
}
exports.default = fallback;
function getResponseBody(response) {
    var stream = response.headers['content-encoding'] === 'gzip'
        ? response.pipe(zlib.createGunzip())
        : response;
    return new Promise(function (resolve, reject) {
        stream.once('error', function (error) {
            stream.removeAllListeners();
            reject(error);
        });
        var body = '';
        stream.on('data', function (chunk) { return (body += chunk); });
        stream.once('end', function () {
            resolve(body);
            stream.removeAllListeners();
        });
    });
}
//# sourceMappingURL=fallback.js.map