import Mocker from './mocker/mocker';
export default class Index {
    /**
     * Auto detect request enviroment and setup request mock.
     * @param {string} type
     */
    static setup(): Mocker;
    /**
     * Setup request mock for wx.request.
     * @param {string} type
     */
    static setupForWx(): Mocker;
    /**
     * Setup request mock for XMLHttpRequest.
     * @param {string} type
     */
    static setupForXhr(): Mocker;
    /**
     * Setup request mock for fetch.
     * @param {string} type
     */
    static setupForFetch(): Mocker;
    /**
     * Setup request mock for node http/https request.
     * @param {string} type
     */
    static setupForNode(): Mocker;
    /**
     * Enable mock function temporarily.
     */
    static enable(): Mocker;
    /**
     * Disable mock function temporarily.
     */
    static disable(): Mocker;
    /**
     * Enable verbose log.
     */
    static enableLog(): Mocker;
    /**
     * Disable verbose log.
     */
    static disableLog(): Mocker;
    /**
     * Setup request mock for unit test.
     * @param {string} type
     */
    static setupForUnitTest(type: 'wx' | 'xhr' | 'fetch' | 'node' | 'node.http.request' | 'all'): Mocker;
}
