/// <reference types="node" />
import http from 'http';
import MockItem from './mocker/mock-item';
export declare enum Method {
    get = "get",
    post = "post",
    put = "put",
    patch = "patch",
    delete = "delete",
    head = "head",
    any = "any"
}
export declare enum Disable {
    yes = "yes",
    no = "no"
}
export interface Query {
    [key: string]: string;
}
export interface Header {
    [key: string]: string;
}
export interface MockItemExt {
    header?: Header;
    disable?: Disable;
    delay?: number;
    times?: number;
    status?: number;
}
export interface MockConfigData {
    [key: string]: MockItem;
}
export interface RequestInfo {
    url: string;
    method: Method;
    query: object;
    headers?: object;
    body?: any;
}
export interface XMLHttpRequestInstance extends XMLHttpRequest {
    bypassMock: boolean;
    isMockRequest: string;
    mockItem: MockItem;
    mockResponse: any;
    requestInfo: RequestInfo;
    requestArgs: any[];
}
export interface WxRequestOpts {
    url: string;
    method?: Method | undefined;
    data?: any;
    header?: object;
    success?: (info: any) => any;
    fail?: (info: any) => any;
    complete?: (info: any) => any;
}
export interface WxRequestTask {
    abort: () => any;
    onHeadersReceived: (callback: Function) => any;
    offHeadersReceived: (callback: Function) => any;
}
export interface ClientRequestType extends http.ClientRequest {
    nativeInstance: null | http.ClientRequest;
    nativeReqestMethod: Function;
    nativeRequestArgs: any[];
    response: http.IncomingMessage;
    requestBody: Buffer;
    mockItemResolver: Function;
    url: string;
    options: {
        [key: string]: any;
    };
    callback: ((...args: any[]) => any) | undefined;
    init: Function;
    setOriginalRequestInfo: Function;
    setMockItemResolver: Function;
    sendResponseResult: Function;
    sendEndingEvent: Function;
    sendError: Function;
    getEndArguments: Function;
    getRequestHeaders: Function;
    bufferToString: Function;
    fallbackToNativeRequest: Function;
}
